---
title: SubtleCrypto.wrapKey()
slug: Web/API/SubtleCrypto/wrapKey
tags:
  - API
  - Method
  - Reference
  - Référence(2)
  - SubtleCrypto
  - Web Crypto API
  - wrapKey
---
<p>{{APIRef("Web Crypto API")}}{{SecureContext_header}}</p>

<p>The <code><strong>wrapKey()</strong></code> method of the {{domxref("SubtleCrypto")}} interface "wraps" a key. This means that it exports the key in an external, portable format, then encrypts the exported key. Wrapping a key helps protect it in untrusted environments, such as inside an otherwise unprotected data store or in transmission over an unprotected network.</p>

<p>As with <code><a href="/en-US/docs/Web/API/SubtleCrypto/exportKey">SubtleCrypto.exportKey()</a></code>, you specify an <a href="/en-US/docs/Web/API/SubtleCrypto/importKey#Supported_formats">export format</a> for the key. To export a key, it must have <a href="/en-US/docs/Web/API/CryptoKey/extractable" title="The CryptoKey.extractable read-only property that indicates if the raw material key can be extracted, for example for archiving it."><code>CryptoKey.extractable</code></a> set to <code>true</code>.</p>

<p>But because <code>wrapKey()</code> also encrypts the key to be imported, you also need to pass in the key that must be used to encrypt it. This is sometimes called the "wrapping key".</p>

<p>The inverse of <code>wrapKey()</code> is {{domxref("SubtleCrypto.unwrapKey()")}}: while <code>wrapKey</code> is composed of export + encrypt, <code>unwrapKey</code> is composed of import + decrypt.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>result</em> = <em>crypto</em><code>.subtle.wrapKey(
    <em>format</em>,
    <em>key</em>,
    <em>wrappingKey</em>,
    <em>wrapAlgo</em>
)</code>;
</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><em><code>format</code></em> is a string describing the data format in which the key will be exported before it is encrypted. It can be one of the following:

  <ul>
   <li><code>raw</code>: <a href="/en-US/docs/Web/API/SubtleCrypto/importKey#Raw">Raw</a> format.</li>
   <li><code>pkcs8</code>: <a href="/en-US/docs/Web/API/SubtleCrypto/importKey#PKCS_8">PKCS #8</a> format.</li>
   <li><code>spki</code>: <a href="/en-US/docs/Web/API/SubtleCrypto/importKey#SubjectPublicKeyInfo">SubjectPublicKeyInfo</a> format.</li>
   <li><code>jwk</code>: <a href="/en-US/docs/Web/API/SubtleCrypto/importKey#JSON_Web_Key">JSON Web Key</a> format.</li>
  </ul>
 </li>
 <li><code><em>key</em></code> is the {{domxref("CryptoKey")}} to wrap.</li>
 <li><code><em>wrappingkey</em></code> is the {{domxref("CryptoKey")}} used to encrypt the exported key. The key must have the <code>wrapKey</code> usage set.</li>
 <li><code><em>wrapAlgo</em></code> is an object specifying the <a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#Supported_algorithms">algorithm</a> to be used to encrypt the exported key, and any required extra parameters:
  <ul>
   <li>To use <a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#RSA-OAEP">RSA-OAEP</a>, pass an <a href="/en-US/docs/Web/API/RsaOaepParams" title="This dictionary represents the object that should be passed as the algorithm parameter into SubtleCrypto.encrypt(), SubtleCrypto.decrypt(), SubtleCrypto.wrapKey(), or SubtleCrypto.unwrapKey(),  when using the RSA_OAEP algorithm."><code>RsaOaepParams</code></a> object.</li>
   <li>To use <a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#AES-CTR">AES-CTR</a>, pass an <a href="/en-US/docs/Web/API/AesCtrParams" title="This dictionary represents the object that should be passed as the algorithm parameter into SubtleCrypto.encrypt(), SubtleCrypto.decrypt(), SubtleCrypto.wrapKey(), or SubtleCrypto.unwrapKey(),  when using the AES-CTR algorithm."><code>AesCtrParams</code></a> object.</li>
   <li>To use <a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#AES-CBC">AES-CBC</a>, pass an <a href="/en-US/docs/Web/API/AesCbcParams" title="This dictionary represents the object that should be passed as the algorithm parameter into SubtleCrypto.encrypt(), SubtleCrypto.decrypt(), SubtleCrypto.wrapKey(), or SubtleCrypto.unwrapKey(), when using the AES-CBC algorithm."><code>AesCbcParams</code></a> object.</li>
   <li>To use <a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#AES-GCM">AES-GCM</a>, pass an <a href="/en-US/docs/Web/API/AesGcmParams" title="This dictionary represents the object that should be passed as the algorithm parameter into SubtleCrypto.encrypt(), SubtleCrypto.decrypt(), SubtleCrypto.wrapKey(), or SubtleCrypto.unwrapKey(),  when using the AES-GCM algorithm."><code>AesGcmParams</code></a> object.</li>
   <li>To use <a href="/en-US/docs/Web/API/SubtleCrypto/wrapKey#AES-KW">AES-KW</a>, pass the string <code>"AES-KW"</code>, or an object of the form <code>{ "name": "AES-KW }</code>.</li>
  </ul>
 </li>
</ul>

<h3 id="Return_value">Return value</h3>

<ul>
 <li><code><em>result</em></code> is a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise" title="The Promise object represents the eventual completion (or failure) of an asynchronous operation, and its resulting value."><code>Promise</code></a> that fulfills with an <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer">ArrayBuffer</a></code> containing the encrypted exported key.</li>
</ul>

<h3 id="Exceptions">Exceptions</h3>

<p>The promise is rejected when one of the following exceptions is encountered:</p>

<dl>
 <dt>{{exception("InvalidAccessError")}}</dt>
 <dd>Raised when the wrapping key is not a key for the requested wrap algorithm.</dd>
 <dt>{{exception("NotSupported")}}</dt>
 <dd>Raised when trying to use an algorithm that is either unknown or isn't suitable for encryption or wrapping.</dd>
 <dt>{{jsxref("TypeError")}}</dt>
 <dd>Raised when trying to use an invalid format.</dd>
</dl>

<h2 id="Supported_algorithms">Supported algorithms</h2>

<p>All <a href="/en-US/docs/Web/API/SubtleCrypto/encrypt#Supported_algorithms">algorithms that are usable for encryption</a> are also usable for key wrapping, as long as the key has the "wrapKey" usage set. For key wrapping you have the additional option of AES-KW.</p>

<h3 id="AES-KW">AES-KW</h3>

<p>AES-KW is a way to use the AES cipher for key wrapping.</p>

<p>One advantage of using AES-KW over another AES mode such as AES-GCM is that AES-KW does not require an initialization vector. To use AES-KW, the input must be a multiple of 64 bits.</p>

<p>AES-KW is specified in <a href="https://tools.ietf.org/html/rfc3394">RFC 3394</a>.</p>

<h2 id="Examples">Examples</h2>

<div class="notecard note">
<p><strong>Note</strong>: You can <a href="https://mdn.github.io/dom-examples/web-crypto/wrap-key/index.html">try the working examples</a> out on GitHub.</p>
</div>

<h3 class="highlight-spanned" id="Raw_wrap"><span class="highlight-span">Raw wrap</span></h3>

<p>This example wraps an AES key. It uses "raw" as the export format and AES-KW, with a password-derived key, to encrypt it. <a class="external external-icon" href="https://github.com/mdn/dom-examples/blob/master/web-crypto/wrap-key/raw.js" rel="noopener">See the complete code on GitHub.</a></p>

<pre class="brush: js">let salt;

/*
Get some key material to use as input to the deriveKey method.
The key material is a password supplied by the user.
*/
function getKeyMaterial() {
  const password = window.prompt("Enter your password");
  const enc = new TextEncoder();
  return window.crypto.subtle.importKey(
    "raw",
    enc.encode(password),
    {name: "PBKDF2"},
    false,
    ["deriveBits", "deriveKey"]
  );
}

/*
Given some key material and some random salt
derive an AES-KW key using PBKDF2.
*/
function getKey(keyMaterial, salt) {
  return window.crypto.subtle.deriveKey(
    {
      "name": "PBKDF2",
      salt: salt,
      "iterations": 100000,
      "hash": "SHA-256"
    },
    keyMaterial,
    { "name": "AES-KW", "length": 256},
    true,
    [ "wrapKey", "unwrapKey" ]
  );
}

/*
Wrap the given key.
*/
async function wrapCryptoKey(keyToWrap) {
  // get the key encryption key
  const keyMaterial = await getKeyMaterial();
  salt = window.crypto.getRandomValues(new Uint8Array(16));
  const wrappingKey = await getKey(keyMaterial, salt);

  return window.crypto.subtle.wrapKey(
    "raw",
    keyToWrap,
    wrappingKey,
    "AES-KW"
  );

}

/*
Generate an encrypt/decrypt secret key,
then wrap it.
*/
window.crypto.subtle.generateKey(
  {
    name: "AES-GCM",
    length: 256,
  },
  true,
  ["encrypt", "decrypt"]
)
.then((secretKey) =&gt; {
  return wrapCryptoKey(secretKey);
})
.then((wrappedKey) =&gt; {
  console.log(wrappedKey);
});

</pre>

<h3 class="highlight-spanned" id="PKCS_8_wrap"><span class="highlight-span">PKCS #8 wrap</span></h3>

<p>This example wraps an RSA private signing key. It uses "pkcs8" as the export format and AES-GCM, with a password-derived key, to encrypt it. <a class="external external-icon" href="https://github.com/mdn/dom-examples/blob/master/web-crypto/wrap-key/pkcs8.js" rel="noopener">See the complete code on GitHub.</a></p>

<pre class="brush: js">let salt;
let iv;

/*
Get some key material to use as input to the deriveKey method.
The key material is a password supplied by the user.
*/
function getKeyMaterial() {
  const password = window.prompt("Enter your password");
  const enc = new TextEncoder();
  return window.crypto.subtle.importKey(
    "raw",
    enc.encode(password),
    {name: "PBKDF2"},
    false,
    ["deriveBits", "deriveKey"]
  );
}

/*
Given some key material and some random salt
derive an AES-GCM key using PBKDF2.
*/
function getKey(keyMaterial, salt) {
  return window.crypto.subtle.deriveKey(
    {
      "name": "PBKDF2",
      salt: salt,
      "iterations": 100000,
      "hash": "SHA-256"
    },
    keyMaterial,
    { "name": "AES-GCM", "length": 256},
    true,
    [ "wrapKey", "unwrapKey" ]
  );
}

/*
Wrap the given key.
*/
async function wrapCryptoKey(keyToWrap) {
  // get the key encryption key
  const keyMaterial = await getKeyMaterial();
  salt = window.crypto.getRandomValues(new Uint8Array(16));
  const wrappingKey = await getKey(keyMaterial, salt);
  iv = window.crypto.getRandomValues(new Uint8Array(12));

  return window.crypto.subtle.wrapKey(
    "pkcs8",
    keyToWrap,
    wrappingKey,
    {
      name: "AES-GCM",
      iv: iv
    }
  );

}

/*
Generate a sign/verify key pair,
then wrap the private key.
*/
window.crypto.subtle.generateKey(
  {
    name: "RSA-PSS",
    // Consider using a 4096-bit key for systems that require long-term security
    modulusLength: 2048,
    publicExponent: new Uint8Array([1, 0, 1]),
    hash: "SHA-256",
  },
  true,
  ["sign", "verify"]
)
.then((keyPair) =&gt; {
  return wrapCryptoKey(keyPair.privateKey);
})
.then((wrappedKey) =&gt; {
  console.log(wrappedKey);
});

</pre>

<h3 class="highlight-spanned" id="SubjectPublicKeyInfo_wrap"><span class="highlight-span">SubjectPublicKeyInfo wrap</span></h3>

<p>This example wraps an RSA public encryption key. It uses "spki" as the export format and AES-CBC, with a password-derived key, to encrypt it. <a class="external external-icon" href="https://github.com/mdn/dom-examples/blob/master/web-crypto/wrap-key/spki.js" rel="noopener">See the complete code on GitHub.</a></p>

<pre class="brush: js">let salt;
let iv;

/*
Get some key material to use as input to the deriveKey method.
The key material is a password supplied by the user.
*/
function getKeyMaterial() {
  const password = window.prompt("Enter your password");
  const enc = new TextEncoder();
  return window.crypto.subtle.importKey(
    "raw",
    enc.encode(password),
    {name: "PBKDF2"},
    false,
    ["deriveBits", "deriveKey"]
  );
}

/*
Given some key material and some random salt
derive an AES-CBC key using PBKDF2.
*/
function getKey(keyMaterial, salt) {
  return window.crypto.subtle.deriveKey(
    {
      "name": "PBKDF2",
      salt: salt,
      "iterations": 100000,
      "hash": "SHA-256"
    },
    keyMaterial,
    { "name": "AES-CBC", "length": 256},
    true,
    [ "wrapKey", "unwrapKey" ]
  );
}

/*
Wrap the given key.
*/
async function wrapCryptoKey(keyToWrap) {
  // get the key encryption key
  const keyMaterial = await getKeyMaterial();
  salt = window.crypto.getRandomValues(new Uint8Array(16));
  const wrappingKey = await getKey(keyMaterial, salt);
  iv = window.crypto.getRandomValues(new Uint8Array(16));

  return window.crypto.subtle.wrapKey(
    "spki",
    keyToWrap,
    wrappingKey,
    {
      name: "AES-CBC",
      iv: iv
    }
  );

}

/*
Generate an encrypt/decrypt key pair,
then wrap it.
*/
window.crypto.subtle.generateKey(
  {
    name: "RSA-OAEP",
    // Consider using a 4096-bit key for systems that require long-term security
    modulusLength: 2048,
    publicExponent: new Uint8Array([1, 0, 1]),
    hash: "SHA-256",
  },
  true,
  ["encrypt", "decrypt"]
)
.then((keyPair) =&gt; {
  return wrapCryptoKey(keyPair.publicKey);
})
.then((wrappedKey) =&gt; {
  console.log(wrappedKey);
});

</pre>

<h3 class="highlight-spanned" id="JSON_Web_Key_import"><span class="highlight-span">JSON Web Key import</span></h3>

<p>This code wraps an ECDSA private signing key. It uses "jwk" as the export format and AES-GCM, with a password-derived key, to encrypt it. <a class="external external-icon" href="https://github.com/mdn/dom-examples/blob/master/web-crypto/wrap-key/jwk.js" rel="noopener">See the complete code on GitHub.</a></p>

<pre class="brush: js">let salt;
let iv;

/*
Get some key material to use as input to the deriveKey method.
The key material is a password supplied by the user.
*/
function getKeyMaterial() {
  const password = window.prompt("Enter your password");
  const enc = new TextEncoder();
  return window.crypto.subtle.importKey(
    "raw",
    enc.encode(password),
    {name: "PBKDF2"},
    false,
    ["deriveBits", "deriveKey"]
  );
}

/*
Given some key material and some random salt
derive an AES-GCM key using PBKDF2.
*/
function getKey(keyMaterial, salt) {
  return window.crypto.subtle.deriveKey(
    {
      "name": "PBKDF2",
      salt: salt,
      "iterations": 100000,
      "hash": "SHA-256"
    },
    keyMaterial,
    { "name": "AES-GCM", "length": 256},
    true,
    [ "wrapKey", "unwrapKey" ]
  );
}

/*
Wrap the given key.
*/
async function wrapCryptoKey(keyToWrap) {
  // get the key encryption key
  const keyMaterial = await getKeyMaterial();
  salt = window.crypto.getRandomValues(new Uint8Array(16));
  const wrappingKey = await getKey(keyMaterial, salt);
  iv = window.crypto.getRandomValues(new Uint8Array(12));

  return window.crypto.subtle.wrapKey(
    "jwk",
    keyToWrap,
    wrappingKey,
    {
      name: "AES-GCM",
      iv: iv
    }
  );
}

/*
Generate a sign/verify key pair,
then wrap the private key
*/
window.crypto.subtle.generateKey(
  {
    name: "ECDSA",
    namedCurve: "P-384"
  },
  true,
  ["sign", "verify"]
)
.then((keyPair) =&gt; {
  return wrapCryptoKey(keyPair.privateKey);
})
.then((wrappedKey) =&gt; {
  console.log(wrappedKey);
});

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('Web Crypto API', '#dfn-SubtleCrypto-method-wrapKey', 'SubtleCrypto.wrapKey()') }}</td>
   <td>{{ Spec2('Web Crypto API') }}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.SubtleCrypto.wrapKey")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/API/SubtleCrypto/exportKey">SubtleCrypto.exportKey()</a></code></li>
 <li><a class="external external-icon" href="https://tools.ietf.org/html/rfc5208" rel="noopener">PKCS #8 format</a>.</li>
 <li><a class="external external-icon" href="https://tools.ietf.org/html/rfc5280#section-4.1" rel="noopener">SubjectPublicKeyInfo format</a>.</li>
 <li><a class="external external-icon" href="https://tools.ietf.org/html/rfc7517" rel="noopener">JSON Web Key format</a>.</li>
 <li><a href="https://tools.ietf.org/html/rfc3394">AES-KW specification</a>.</li>
</ul>
